package com.arms.api.issue.almapi.model.vo;

import com.arms.api.issue.almapi.model.dto.요구사항_데이터;
import com.arms.egovframework.javaservice.esframework.erros.response.ErrorCode;
import lombok.extern.slf4j.Slf4j;

import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;

@Slf4j
public class 지라이슈_벌크_추가_유효성_체크 implements ConstraintValidator<지라이슈_벌크_추가_요청_유효성, 요구사항_데이터> {


    @Override
    public boolean isValid(요구사항_데이터 요구사항_데이터, ConstraintValidatorContext context) {

        context.disableDefaultConstraintViolation();

        if (요구사항_데이터.get지라서버_아이디() == null) {
            context.buildConstraintViolationWithTemplate("지라이슈_벌크_추가하기 Error: 서버_아이디 " + ErrorCode.파라미터_서버_아이디_없음.getErrorMsg())
                .addConstraintViolation();
            return false;
        }

        if (요구사항_데이터.get이슈_키() == null || 요구사항_데이터.get이슈_키().isEmpty()) {
            context.buildConstraintViolationWithTemplate("지라이슈_벌크_추가하기 Error 이슈_키 " + ErrorCode.파라미터_NULL_오류.getErrorMsg())
                .addConstraintViolation();
            return false;
        }

        if (요구사항_데이터.get프로젝트키_또는_아이디() == null
            || 요구사항_데이터.get프로젝트키_또는_아이디().isEmpty()) {
            context.buildConstraintViolationWithTemplate("지라이슈_벌크_추가하기 Error 프로젝트키_또는_아이디 " + ErrorCode.파라미터_NULL_오류.getErrorMsg())
                .addConstraintViolation();
            return false;
        }

        if (요구사항_데이터.get제품서비스_아이디() == null
            || 요구사항_데이터.get제품서비스_버전들() == null
            || 요구사항_데이터.get제품서비스_버전들().size()==0) {
            context.buildConstraintViolationWithTemplate("지라이슈_벌크_추가하기 Error 제품서비스_아이디 또는 제품서비스_버전 " + ErrorCode.파라미터_NULL_오류.getErrorMsg())
                .addConstraintViolation();
            return false;
        }

        if (요구사항_데이터.getCReqLink() == null) {
            context.buildConstraintViolationWithTemplate("지라이슈_벌크_추가하기 Error cReqLink " + ErrorCode.파라미터_NULL_오류.getErrorMsg())
                .addConstraintViolation();
            return false;
        }


        return  true;
    }
}
