package com.arms.api.issue.schedule.controller;

import com.arms.api.issue.almapi.model.entity.AlmIssueEntity;
import com.arms.api.issue.almapi.model.dto.암스_요구사항_속성정보;
import com.arms.api.issue.almapi.model.dto.요구사항_데이터;
import com.arms.api.issue.schedule.service.이슈_스케쥴_서비스;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("/engine/jira/{connectId}/issue")
@Slf4j
public class 이슈_스케쥴_컨트롤러 {


    @Autowired
    private 이슈_스케쥴_서비스 이슈_스케쥴_서비스;

    // 스케쥴러 컨트롤러
    @ResponseBody
    @GetMapping("/get/{reqProjectKey}/{reqIssueKey}")
    public AlmIssueEntity 요구사항이슈_조회(@PathVariable("connectId") Long 지라서버_아이디,
                                            @PathVariable("reqProjectKey") String 지라프로젝트_키,
                                            @PathVariable("reqIssueKey") String 지라이슈_키) {

        String 조회조건_아이디 = 지라서버_아이디 + "_" + 지라프로젝트_키 + "_" + 지라이슈_키;

        log.info("[ 이슈_스케줄_컨트롤러 :: 요구사항이슈_조회 ] :: 조회조건_아이디 = {}", 조회조건_아이디);

        return 이슈_스케쥴_서비스.이슈_조회하기(조회조건_아이디);
    }

    @ResponseBody
    @RequestMapping(
            value = {"/documents"},
            method = {RequestMethod.DELETE}
    )
    public int 삭제대상_이슈_도큐먼트_삭제() {

        log.info("[ 이슈_스케줄_컨트롤러 :: 삭제대상_이슈_도큐먼트_삭제 ]");

        return 이슈_스케쥴_서비스.삭제대상_이슈_도큐먼트_삭제();

    }

    @ResponseBody
    @RequestMapping(
            value = {"/update/field/upperKey/{issueKey}"},
            method = {RequestMethod.POST}
    )
    public int 서브테스크_상위키_필드업데이트(@PathVariable("connectId") Long 지라서버_아이디,
                                            @PathVariable("issueKey") String 이슈_키,
                                            @RequestParam("pdServiceId") Long 제품서비스_아이디,
                                            @RequestParam("pdServiceVersions") List<Long> 제품서비스_버전_아이디들,
                                            @RequestParam("cReqLink") Long cReqLink,
                                            @RequestParam("projectKeyOrId") String 프로젝트키_또는_아이디,
                                            암스_요구사항_속성정보 암스_요구사항_속성정보,
                                            ModelMap model, HttpServletRequest request) throws Exception {

        log.info("[ 이슈_스케줄_컨트롤러 :: 서브테스크_상위키_필드업데이트 ] :: 지라서버 아이디 : {},\t이슈 키 : {},\t프로젝트키_또는_아이디 : {},\t제품서비스 아이디 : {},\t제품서비스 버전 목록 : {}"
                , 지라서버_아이디, 이슈_키, 프로젝트키_또는_아이디, 제품서비스_아이디, 제품서비스_버전_아이디들);

        요구사항_데이터 요구사항 = 요구사항_데이터.builder()
                .지라서버_아이디(지라서버_아이디)
                .이슈_키(이슈_키)
                .제품서비스_아이디(제품서비스_아이디)
                .제품서비스_버전들(제품서비스_버전_아이디들)
                .cReqLink(cReqLink)
                .cReqProperty(암스_요구사항_속성정보)
                .프로젝트키_또는_아이디(프로젝트키_또는_아이디).build();

        return 이슈_스케쥴_서비스.서브테스크_상위키_필드업데이트(요구사항);
    }

    // 스케쥴러 컨트롤러
    @ResponseBody
    @RequestMapping(
            value = {"/loadToES/bulk/{issueKey}"},
            method = {RequestMethod.GET}
    )
    public List<AlmIssueEntity> 요구사항_이슈_수집(@PathVariable("connectId") Long 지라서버_아이디,
                                                    @PathVariable("issueKey") String 이슈_키,
                                                    @RequestParam("pdServiceId") Long 제품서비스_아이디,
                                                    @RequestParam("pdServiceVersions") List<Long> 제품서비스_버전_아이디들,
                                                    @RequestParam("cReqLink") Long cReqLink,
                                                    @RequestParam("projectKeyOrId") String 프로젝트키_또는_아이디,
                                                    암스_요구사항_속성정보 암스_요구사항_속성정보,
                                                    ModelMap model, HttpServletRequest request) throws Exception {

        log.info(" [ 이슈_스케줄_컨트롤러 :: 요구사항_이슈_수집 ] :: 지라서버 아이디 : {},\t이슈 키 : {},\t프로젝트키_또는_아이디 : {},\t제품서비스 아이디 : {},\t제품서비스 버전 목록 : {}"
                , 지라서버_아이디, 이슈_키, 프로젝트키_또는_아이디, 제품서비스_아이디, 제품서비스_버전_아이디들);

        요구사항_데이터 요구사항 = 요구사항_데이터.builder()
                .지라서버_아이디(지라서버_아이디)
                .이슈_키(이슈_키)
                .제품서비스_아이디(제품서비스_아이디)
                .제품서비스_버전들(제품서비스_버전_아이디들)
                .cReqLink(cReqLink)
                .cReqProperty(암스_요구사항_속성정보)
                .프로젝트키_또는_아이디(프로젝트키_또는_아이디).build();

        return 이슈_스케쥴_서비스.요구사항_이슈_수집(요구사항);
    }

    @ResponseBody
    @RequestMapping(
            value = {"/loadToES/bulk/subtask/{issueKey}"},
            method = {RequestMethod.GET}
    )
    public int 하위이슈_수집(@PathVariable("connectId") Long 지라서버_아이디,
                                @PathVariable("issueKey") String 이슈_키,
                                @RequestParam("pdServiceId") Long 제품서비스_아이디,
                                @RequestParam("pdServiceVersions") List<Long> 제품서비스_버전_아이디들,
                                @RequestParam("cReqLink") Long cReqLink,
                                @RequestParam("projectKeyOrId") String 프로젝트키_또는_아이디,
                                암스_요구사항_속성정보 암스_요구사항_속성정보,
                                ModelMap model, HttpServletRequest request) throws Exception {

        log.info(" [ 이슈_스케줄_컨트롤러 :: 하위이슈_수집 ] :: 지라서버 아이디 : {},\t이슈 키 : {},\t프로젝트키_또는_아이디 : {},\t제품서비스 아이디 : {},\t제품서비스 버전 목록 : {}"
                , 지라서버_아이디, 이슈_키, 프로젝트키_또는_아이디, 제품서비스_아이디, 제품서비스_버전_아이디들);

        요구사항_데이터 요구사항 = 요구사항_데이터.builder()
                .지라서버_아이디(지라서버_아이디)
                .이슈_키(이슈_키)
                .제품서비스_아이디(제품서비스_아이디)
                .제품서비스_버전들(제품서비스_버전_아이디들)
                .cReqLink(cReqLink)
                .cReqProperty(암스_요구사항_속성정보)
                .프로젝트키_또는_아이디(프로젝트키_또는_아이디).build();

        return 이슈_스케쥴_서비스.하위이슈_수집(요구사항);
    }

    @ResponseBody
    @RequestMapping(
            value = {"/loadToES/bulk/linkedIssue/{issueKey}"},
            method = {RequestMethod.GET}
    )
    public int 연결이슈_수집(@PathVariable("connectId") Long 지라서버_아이디,
                                    @PathVariable("issueKey") String 이슈_키,
                                    @RequestParam("pdServiceId") Long 제품서비스_아이디,
                                    @RequestParam("pdServiceVersions") List<Long> 제품서비스_버전_아이디들,
                                    @RequestParam("cReqLink") Long cReqLink,
                                    @RequestParam("projectKeyOrId") String 프로젝트키_또는_아이디,
                                    암스_요구사항_속성정보 암스_요구사항_속성정보,
                                    ModelMap model, HttpServletRequest request) throws Exception {

        log.info(" [ 이슈_스케줄_컨트롤러 :: 연결이슈_수집 ] :: 지라서버 아이디 : {},\t이슈 키 : {},\t프로젝트키_또는_아이디 : {},\t제품서비스 아이디 : {},\t제품서비스 버전 목록 : {}"
                , 지라서버_아이디, 이슈_키, 프로젝트키_또는_아이디, 제품서비스_아이디, 제품서비스_버전_아이디들);

        요구사항_데이터 요구사항 = 요구사항_데이터.builder()
                .지라서버_아이디(지라서버_아이디)
                .이슈_키(이슈_키)
                .제품서비스_아이디(제품서비스_아이디)
                .제품서비스_버전들(제품서비스_버전_아이디들)
                .cReqLink(cReqLink)
                .cReqProperty(암스_요구사항_속성정보)
                .프로젝트키_또는_아이디(프로젝트키_또는_아이디).build();

        return 이슈_스케쥴_서비스.연결이슈_수집(요구사항);
    }

    // 스케쥴러 컨트롤러
    @ResponseBody
    @RequestMapping(
            value = {"/increment/loadToES/bulk/subtask/{issueKey}"},
            method = {RequestMethod.GET}
    )

    public int 증분_하위이슈_수집(@PathVariable("connectId") Long 지라서버_아이디,
                                    @PathVariable("issueKey") String 이슈_키,
                                    @RequestParam("pdServiceId") Long 제품서비스_아이디,
                                    @RequestParam("pdServiceVersions") List<Long> 제품서비스_버전_아이디들,
                                    @RequestParam("cReqLink") Long cReqLink,
                                    @RequestParam("projectKeyOrId") String 프로젝트키_또는_아이디,
                                    암스_요구사항_속성정보 암스_요구사항_속성정보,
                                    @RequestParam(value = "startDate",required = false) String startDate,
                                    @RequestParam(value = "endDate",required = false) String endDate) throws Exception {

        log.info("[ 이슈_스케줄_컨트롤러 :: 증분_하위이슈_수집 ] :: 지라서버 아이디 : {},\t이슈 키 : {},\t프로젝트키_또는_아이디 : {},\t제품서비스 아이디 : {},\t제품서비스 버전 목록 : {}"
                , 지라서버_아이디, 이슈_키, 프로젝트키_또는_아이디, 제품서비스_아이디, 제품서비스_버전_아이디들);

        요구사항_데이터 요구사항 = 요구사항_데이터.builder()
                .지라서버_아이디(지라서버_아이디)
                .이슈_키(이슈_키)
                .제품서비스_아이디(제품서비스_아이디)
                .제품서비스_버전들(제품서비스_버전_아이디들)
                .cReqLink(cReqLink)
                .cReqProperty(암스_요구사항_속성정보)
                .프로젝트키_또는_아이디(프로젝트키_또는_아이디)
                .startDate(startDate)
                .endDate(endDate)
                .build();

        return 이슈_스케쥴_서비스.증분_하위이슈_수집(요구사항);
    }

}
